#include <linux/config.h>
#include <linux/module.h>
#include <linux/errno.h>
#include <linux/signal.h>
#include <linux/tty.h>
#include <linux/tty_flip.h>
#include <linux/major.h>
#include <linux/string.h>
#include <linux/fcntl.h>
#include <linux/ptrace.h>
#include <linux/ioport.h>
#include <linux/mm.h> 
#include <linux/init.h>
#include <linux/circ_buf.h>
#include <linux/serial.h>
#include <linux/console.h>
#include <linux/sysrq.h>

#include <asm/system.h>
#include <asm/irq.h>
#include <asm/uaccess.h>
#include <asm/bitops.h>
#include <asm/hardware.h>
#include <linux/serial_core.h>

int ROBOBLOCK_MAJOR = 0;
int int_count = 0;

int roboblock_ioctl(struct inode *inode, struct file *filp, unsigned int cmd, unsigned long arg);


int roboblock_open (struct inode *inode, struct file *filp)
{
    printk("module : roboblock_open\n");
    MOD_INC_USE_COUNT;
    return 0;          /* success */
}

int roboblock_release (struct inode *inode, struct file *filp)
{
    printk("module : roboblock_close\n");
    MOD_DEC_USE_COUNT;
    return 0;
}

ssize_t roboblock_read (struct file *filp, char *buf, size_t count, loff_t *f_pos)
{
	char data[] = "read";

	copy_to_user(buf, data, count);
	return(count);
}

ssize_t roboblock_write (struct file *filp, const char *buf, size_t count, loff_t *f_pos)
{
	char data[8];

	copy_from_user(data, buf, count);

	printk("module : data is >>>> %s", data);
	return(count);
}

int roboblock_ioctl(struct inode *inode, struct file *filp, unsigned int cmd, unsigned long arg)
{
        switch(cmd)
        {
 		case 1:  
                {
			printk("\n");
			printk("module : cmd = 1\n");
                      break;
                }
                case 2:
                {
			printk("\n");
			printk("module : cmd = 2\n");
                       break;
                }
                case 3:
                {
			printk("\n");
			printk("module : cmd = 3\n");
                       break;
                }
                case 4:
                {
			printk("\n");
			printk("module : cmd = 4\n");
 		       break;
                }
                                          
                case 5:
                {
			printk("\n");
			printk("module : cmd = 5\n");
                        break;
                }
                case 6:
                {
			printk("\n");
			printk("module : cmd = 6\n");
			break;
                }
                case 7:
                {
			printk("\n");
			printk("module : cmd = 7\n");
                        break;
                }
                case 8:
                {
			printk("\n");
			printk("module : cmd = 8\n");
                        break;
                }
                case 9:
                {
			printk("\n");
			printk("module : cmd = 9\n");
                        break;
                }
                default:
                        return 0;
        }
        return 0;
}

		
struct file_operations roboblock_fops = {
    read:       roboblock_read,
    write:      roboblock_write,
    open:       roboblock_open,
    ioctl:	roboblock_ioctl,
    release:    roboblock_release,
};


static int __init roboblock_init(void)
{
    int result;

    result = register_chrdev(ROBOBLOCK_MAJOR, "ROBOBLOCK", &roboblock_fops);
    if (result < 0) {
        printk(KERN_WARNING " can't get major \n");
        return result;
    }
    if(ROBOBLOCK_MAJOR == 0)
	ROBOBLOCK_MAJOR = result;

    printk("module : ROBOBLOCK_MAJOR = %d\n", ROBOBLOCK_MAJOR);
    return 0;
}

static void __exit roboblock_exit(void)
{
	unregister_chrdev(ROBOBLOCK_MAJOR, "ROBOBLOCK");
		
}

module_init(roboblock_init);
module_exit(roboblock_exit);

